@page "/grouphub"

@using AntDesign
@using System.ComponentModel
@using System.Text;
@using System.Net;
@using FIOWeb.Models
@using FIOWeb.JsonPayloads
@using Newtonsoft.Json
@using CurrieTechnologies.Razor.Clipboard

@inject ClipboardService Clipboard
@inject IMatToaster Toaster
@inject NavigationManager NavManager
@inject GlobalAppState GlobalAppState

@implements IDisposable

<link href="./css/page-specific/GroupHub.css?lastup=20210425121800" rel="stylesheet" />
<link href="./css/materials.css?lastup=20210425121800" rel="stylesheet"/>

<FIOWeb.Components.LoadingWrapper RequiresAuth="true" @bind-ProgressCount="ProgressCount" TotalProgress="1">
    <h1 class="group_name">@GroupHubModel.GroupName</h1>
    <div class="cx_warehouses">
        @foreach (var cx_warehouse in GroupHubModel.CXWarehouses)
        {
            @if(cx_warehouse.PlayerCXWarehouses.Count > 0 && cx_warehouse.PlayerCXWarehouses.Any(pcw => pcw.Items.Count > 0))
            {
                <h3 class="cx_warehouse_name">@cx_warehouse.WarehouseLocationName</h3>
                <div class="cx_warehouse">
                @foreach (var player_war_inventory in cx_warehouse.PlayerCXWarehouses)
                {
                    @if ( player_war_inventory.Items.Count > 0 )
                    {
                        <div class="cx_warehouse_player">
                            <h4 class="cx_warehouse_player_name">@player_war_inventory.PlayerName <sup>@player_war_inventory.LastUpdated.ToUpdatedAgo()</sup></h4>
                            <div class="cx_warehouse_player_inventory">
                                @foreach (var inventory_item in player_war_inventory.Items)
                                {
                                    <span class="inventory_item @inventory_item.MaterialType.ToLower()">
                                        <span class="inventory_amount">@inventory_item.Units</span>
                                        <span class="inventory_ticker">@inventory_item.MaterialTicker</span>
                                    </span>
                                }
                            </div>
                        </div>
                    }
                        
                }
            </div>
            }
               
        }
    </div>

    @if (GroupHubModel.PlayerShipsInFlight.Count > 0)
    {
        <h3 class="flights_header">Ships In Flight</h3>
        <table class="flights_table">
            <tr class="flights_table_header_row">
                <th class="flights_table_header_row_field">Player</th>
                <th class="flights_table_header_row_field">Ship</th>
                <th class="flights_table_header_row_field">Location</th>
                <th class="flights_table_header_row_field">Destination</th>
                <th class="flights_table_header_row_field">ETA</th>
                <th class="flights_table_header_row_field">Fuel</th>
            </tr>

            @foreach (var ship in GroupHubModel.PlayerShipsInFlight)
            {
                @if (ship.LocationETALocalTime != null && ship.LocationETALocalTime > DateTime.Now)
                {
                    <tr class="flights_table_row">
                        <td class="flights_table_row_cell">@ship.PlayerName <sup>@ship.LastUpdated.ToUpdatedAgo()</sup></td>
                        <td class="flights_table_row_cell">@ship.ShipName</td>
                        <td class="flights_table_row_cell">@ship.Location</td>
                        <td class="flights_table_row_cell">@ship.Destination</td>
                        <td class="flights_table_row_cell">@(ship.LocationETALocalTime != null ? ((DateTime)ship.LocationETALocalTime).ToString() : "")</td>
                        <td class="flights_table_row_cell">
                            <p class="flights_table_row_cell_fuel">@ship.Fuel.CurrentFF / @ship.Fuel.MaxFF</p>
                            <p class="flights_table_row_cell_fuel">@ship.Fuel.CurrentSF / @ship.Fuel.MaxSF</p>
                        </td>
                    </tr>

                        <tr class="flights_table_cargo_row">
                        <h3 class="flights_table_cargo_row_header">Cargo</h3>
                        <div class="flights_table_cargo_row_items">
                            @if (ship.Cargo.Items.Count == 0)
                            {
                                <span class="inventory_amount">Empty</span>
                            }
                            @foreach (var cargo_inventory_item in ship.Cargo.Items)
                            {
                                <span class="inventory_item @cargo_inventory_item.MaterialType.ToLower()">
                                    <span class="inventory_amount">@cargo_inventory_item.Units</span>
                                    <span class="inventory_ticker">@cargo_inventory_item.MaterialTicker</span>
                                </span>
                            }
                        </div>
                    </tr>
                }
            }
        </table>
    }

    @foreach (var player in GroupHubModel.PlayerModels)
    {
        <div class="player">
            <h3 class="player_name">@player.UserName</h3>
            @if ( player.Currencies.Count > 0 )
            {
                <h4 class="player_currency_header">Currency: </h4>
                <div class="player_currency">
                    @foreach (var currency in player.Currencies)
                    {
                        <span class="player_currency_span">@currency.Amount.ToString("N2") @currency.CurrencyName <sup>@currency.LastUpdated.ToUpdatedAgo()</sup></span>
                    }
                </div>
            }

            @foreach (var location in player.Locations)
            {
                <div class="player_location">
                    <h3 class="player_location_name">
                        @(location.LocationIdentifier == location.LocationName ? location.LocationIdentifier : $"{location.LocationName} ({location.LocationIdentifier})")
                        <sup>
                            @if (location.BaseStorage != null)
                            {
                                @location.BaseStorage.LastUpdated.ToUpdatedAgo()    
                            }
                        </sup>
                    </h3>
                    <div class="player_productions">
                        @foreach (var productionLine in location.ProductionLines)
                        {
                            <div>
                                <table class="flights_table">
                                    <tr>
                                        <th>
                                            <h4 class="player_location_building_name">@productionLine.BuildingTicker x @productionLine.Capacity</h4><br/>
                                            <div class="player_production_orders">
                                                @foreach (var productionOrder in productionLine.ProductionOrders)
                                                {
                                                    <div class="player_production_order">
                                                        <div class="player_production_order_output">
                                                            @foreach (var output in productionOrder.Outputs)
                                                            {
                                                                <span class="inventory_item @output.MaterialType.ToLower()">
                                                                    <span class="inventory_amount">@output.Units</span>
                                                                    <span class="inventory_ticker">@output.MaterialTicker</span>
                                                                </span>
                                                            }
                                                            @if (productionOrder.TimeCompletion != null)
                                                            {
                                                                <span class="player_production_order_completion">Completion: @(productionOrder.TimeCompletion.ToCompletionTime())
                                                                    <sup>
                                                                        @if (productionOrder.TimeCompletion != null && DateTime.UtcNow > productionOrder.TimeCompletion)
                                                                        {
                                                                            @productionOrder.LastUpdated.ToUpdatedAgo()
                                                                        }
                                                                    </sup>
                                                                </span>
                                                            }
                                                            else
                                                            {
                                                                @if (productionOrder.Recurring)
                                                                {
                                                                    <span class="player_production_order_queue">Queued (Recurring)</span>
                                                                }
                                                                else
                                                                {
                                                                    <span class="player_production_order_queue">Queued</span>
                                                                }
                                                            }
                                                        </div>

                                                        @if (Utils.False)
                                                        {
                                                        <div class="player_production_order_inputs">
                                                            @foreach (var input in productionOrder.Inputs)
                                                            {
                                                            <div class="player_production_order_input">
                                                                <span class="inventory_item @input.MaterialType.ToLower()">
                                                                    <span class="inventory_amount">@getDailyConsumption(productionOrder.OrderDuration, input.Units)</span>
                                                                    <span class="inventory_ticker">@input.MaterialTicker</span>
                                                                </span>
                                                                <span class="player_production_order_per_day"> / day</span>
                                                            </div>
                                                            }
                                                        </div>
                                                        }
                                                    </div>
                                                }
                                            </div>
                                        </th>
                                    </tr>
                                </table>
                            </div>
                        }
                    </div>
                </div>

                <div class="player_location_base">
                    @if (location.BaseStorage != null)
                    {
                        <h3 class="player_location_base_header">Base Inventory<sup>@location.BaseStorage.LastUpdated.ToUpdatedAgo()</sup></h3>
                        <div class="player_location_base_inventory">
                            @if (location.BaseStorage.Items.Count == 0)
                            {
                                <span class="inventory_amount">Empty</span>
                            }
                            @foreach (var base_inventory_item in location.BaseStorage.Items)
                            {
                                <span class="inventory_item @base_inventory_item.MaterialType.ToLower()">
                                    <span class="inventory_amount">@base_inventory_item.Units</span>
                                    <span class="inventory_ticker">@base_inventory_item.MaterialTicker</span>
                                </span>
                            }
                        </div>
                    }
                </div>

                <div class="player_location_warehouse">
                    @if (location.WarehouseStorage != null)
                    {
                        // TODO CGS create a method/module for inventory display (the part with the div then foreach then span)
                        <h3 class="player_location_warehouse_header">Warehouse Inventory<sup>@location.WarehouseStorage.LastUpdated.ToUpdatedAgo()</sup></h3>
                        <div class="player_location_warehouse_inventory">
                            @foreach (var warehouse_inventory_item in location.WarehouseStorage.Items)
                            {
                                <span class="inventory_item @warehouse_inventory_item.MaterialType.ToLower()">
                                    <span class="inventory_amount">@warehouse_inventory_item.Units</span>
                                    <span class="inventory_ticker">@warehouse_inventory_item.MaterialTicker</span>
                                </span>
                            }
                        </div>
                    }
                </div>

                <div class="player_location_ships">
                    @if (location.StationaryPlayerShips.Count > 0)
                    {
                        <h3 class="player_location_ships_header">Stationary Ships</h3>
                        <table class="player_location_ships_table">
                            <tr class="player_location_ships_table_header_row">
                                <th class="player_location_ships_table_header_field">Player</th>
                                <th class="player_location_ships_table_header_field">Ship</th>
                                <th class="player_location_ships_table_header_field">Location</th>
                                <th class="player_location_ships_table_header_field">Fuel</th>
                            </tr>

                            @foreach (var ship in location.StationaryPlayerShips)
                            {
                                <tr class="player_location_ships_table_row">
                                    <td class="player_location_ships_table_row_cell">@ship.PlayerName <sup>@ship.LastUpdated.ToUpdatedAgo()</sup></td>
                                    <td class="player_location_ships_table_row_cell">@ship.ShipName</td>
                                    <td class="player_location_ships_table_row_cell">@ship.Location</td>
                                    <td class="player_location_ships_table_row_cell">@ship.PlayerName</td>
                                    <td class="player_location_ships_table_row_cell">
                                        <p class="player_location_ships_table_row_cell_fuel">@ship.Fuel.CurrentFF / @ship.Fuel.MaxFF</p>
                                        <p class="player_location_ships_table_row_cell_fuel">@ship.Fuel.CurrentSF / @ship.Fuel.MaxSF</p>
                                    </td>
                                </tr>

                                <tr class="player_location_ships_table_cargo_row">
                                    <h3 class="player_location_ships_table_cargo_row_header">Cargo</h3>
                                    <div class="player_location_ships_table_cargo_row_items">
                                        @if (ship.Cargo.Items.Count == 0)
                                        {
                                            <span class="inventory_amount">Empty</span>
                                        }
                                        @foreach (var cargo_inventory_item in ship.Cargo.Items)
                                        {
                                            <span class="inventory_item @cargo_inventory_item.MaterialType.ToLower()">
                                                <span class="inventory_amount">@cargo_inventory_item.Units</span>
                                                <span class="inventory_ticker">@cargo_inventory_item.MaterialTicker</span>
                                            </span>
                                        }
                                    </div>
                                </tr>
                            }
                        </table>
                    }
                </div>
            }
        </div>
    <br/>
    <hr>
    <br/>
    }
</FIOWeb.Components.LoadingWrapper>